#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  MediumVioletRed

extern  int      MinBars = 0;

int      PreBars;
datetime BarTime;
int      StartPos;
int      pos;

double   Kalman[], Prognoz[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  SetIndexBuffer(0,Kalman);
  SetIndexBuffer(1,Prognoz);
  SetIndexStyle(0,DRAW_LINE);
  SetIndexStyle(1,DRAW_LINE);
//----      
  SetIndexEmptyValue(0,0.0);
  SetIndexEmptyValue(1,0.0);
  SetIndexLabel(0,"Kalman");
  SetIndexLabel(1,"Prognoz");
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  return(0);
}
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
int Reset() {
  if (MinBars == 0) MinBars = Bars-2;
  StartPos = MinBars;
  PreBars = 0;
  BarTime = 0;
// .......
  StartPos++;
  return(StartPos);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
double K_1=1, K_2=1;
//      
  if (Bars == PreBars) return(0);  
//  ,     
  if (Bars < MinBars) {
    Alert(":    ");
    return(0);
  }  
//      ,    
  if (Bars-PreBars == 1 && BarTime==Time[1]) StartPos = 1;
//       Reset()   
  else StartPos = Reset();
//   
  PreBars = Bars;  
  BarTime = Time[0];
//   
  for (pos=StartPos;pos>0;pos--) {
//   .....
// ......
//  ()   
   Kalman[pos]=K_1*Close[pos];      //   
//    
   Prognoz[pos-1]=K_2*Kalman[pos]; //   

  }  //  pos=StartPos;pos>0;pos--) 
  return(0);
}